> For the complete documentation index, see [llms.txt](https://boxlang.ortusbooks.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://boxlang.ortusbooks.com/boxlang-language/reference/built-in-functions/conversion/jsonserialize.md).

# JSONSerialize

Converts a BoxLang variable into a JSON (JavaScript Object Notation) string according to the specified options.

## Query Format Options

The `queryFormat` argument determines how queries are serialized:

* `row` or `false`: Serializes the query as a top-level struct with two keys: `columns` (an array of column names) and `data` (an array of arrays representing each row's data).
* `column` or `true`: Serializes the query as a top-level struct with three keys: `rowCount` (the number of rows), `columns` (an array of column names), and `data` (a struct where each key is a column name and the value is an array of values for that column).
* `struct`: Serializes the query as an array of structs, where each struct represents a row of data.

## Usage

```
 // Convert a query to JSON
 myQuery = ...;
 json = jsonSerialize( myQuery, queryFormat="row" );
 // Convert a list to JSON
 myList = "foo,bar,baz";
 jsonList = jsonSerialize( myList );
 
```

## Method Signature

```
JSONSerialize(data=[any], queryFormat=[string], useSecureJSONPrefix=[string], useCustomSerializer=[boolean], pretty=[boolean])
```

### Arguments

| Argument              | Type      | Required | Description                                                                                                                                                                                                                                                               | Default |
| --------------------- | --------- | -------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------- |
| `data`                | `any`     | `true`   | The variable to convert to a JSON string.                                                                                                                                                                                                                                 |         |
| `queryFormat`         | `string`  | `false`  | <p>If the variable is a query, specifies whether to serialize the query by rows or by columns. Valid values are:<br><code>row</code> same as <code>false</code>, <code>column</code> same as <code>true</code>, or <code>struct</code>. Defaults to <code>row</code>.</p> |         |
| `useSecureJSONPrefix` | `string`  | `false`  | If true, the JSON string is prefixed with a secure JSON prefix. (Not implemented yet)                                                                                                                                                                                     | `false` |
| `useCustomSerializer` | `boolean` | `false`  | If true, the JSON string is serialized using a custom serializer. (Not implemented yet)                                                                                                                                                                                   |         |
| `pretty`              | `boolean` | `false`  | If true, the JSON string is formatted with indentation and line breaks for readability. Defaults to false.                                                                                                                                                                | `false` |

## Examples

### Serialize a struct to JSON

```java
data = { name: "Luis", age: 42 };
result = jsonSerialize( data );
writeOutput( result.contains( "Luis" ) );

```

Result: true

### Serialize an array to JSON

```java
items = [ 1, 2, 3 ];
result = jsonSerialize( items );
writeOutput( result );

```

Result: \[1,2,3]

## Related

* [DataNavigate](/boxlang-language/reference/built-in-functions/conversion/datanavigate.md)
* [JSONDeserialize](/boxlang-language/reference/built-in-functions/conversion/jsondeserialize.md)
* [JSONPrettify](/boxlang-language/reference/built-in-functions/conversion/jsonprettify.md)
* [LSParseNumber](/boxlang-language/reference/built-in-functions/conversion/lsparsenumber.md)
* [ParseNumber](/boxlang-language/reference/built-in-functions/conversion/parsenumber.md)
* [ToBase64](/boxlang-language/reference/built-in-functions/conversion/tobase64.md)
* [ToBinary](/boxlang-language/reference/built-in-functions/conversion/tobinary.md)
* [ToModifiable](/boxlang-language/reference/built-in-functions/conversion/tomodifiable.md)
* [ToNumeric](/boxlang-language/reference/built-in-functions/conversion/tonumeric.md)
* [ToScript](/boxlang-language/reference/built-in-functions/conversion/toscript.md)
* [ToString](/boxlang-language/reference/built-in-functions/conversion/tostring.md)
* [ToUnmodifiable](/boxlang-language/reference/built-in-functions/conversion/tounmodifiable.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://boxlang.ortusbooks.com/boxlang-language/reference/built-in-functions/conversion/jsonserialize.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
